import os
from cudatext import *
from random import randint


def callback_main_close(id_dlg, id_ctl, data='', info=''):
    print('callback_main_close')

    dlg_proc(id_dlg, DLG_HIDE)

    #hide tab added to sidebar
    app_proc(PROC_SIDEPANEL_REMOVE, 'Side dialog')
    app_proc(PROC_SIDEPANEL_ACTIVATE, 'Tree')

def callback_main_menu(id_dlg, id_ctl, data='', info=''):
    print('callback_main_menu')
    nctl = dlg_proc(id_dlg, DLG_CTL_FIND, prop='btn_menu')
    d = dlg_proc(id_dlg, DLG_CTL_PROP_GET, index=nctl)

    nx = d['x']
    ny = d['y']+d['h']
    nx, ny = dlg_proc(id_dlg, DLG_COORD_LOCAL_TO_SCREEN, index=nx, index2=ny)

    h_menu = menu_proc(0, MENU_CREATE)
    menu_proc(h_menu, MENU_ADD, command=2700, caption='About1')
    menu_proc(h_menu, MENU_ADD, command=2700, caption='About2')
    menu_proc(h_menu, MENU_ADD, command=2700, caption='About3')
    menu_proc(h_menu, MENU_SHOW, command='%d,%d'%(nx, ny))


class Command:
    border = True

    def run_modal(self):
        print('run_modal begin')
        h = self.init_maindlg()
        dlg_proc(h, DLG_SHOW_MODAL)
        self.show_form_prop(h)
        dlg_proc(h, DLG_FREE)
        print('run_modal end')

    def run_nonmodal(self):
        h = self.init_maindlg()
        dlg_proc(h, DLG_SHOW_NONMODAL)

    def run_dlgcustom(self):
        dlg_custom('TestDlg', 200, 100, 'type=label\1pos=6,6,200,0\1cap=Test')

    def callback_linklabel_click(self, id_dlg, id_ctl, data='', info=''):
        msg_box('Linklabel clicked', MB_OK)

    def callback_buttondlg(self, id_dlg, id_ctl, data='', info=''):
        h = id_dlg
        n_btn_border = dlg_proc(h, DLG_CTL_FIND, prop='btn_border')
        n_btn_icon = dlg_proc(h, DLG_CTL_FIND, prop='btn_icon')

        if id_ctl==n_btn_border:
            self.border = not self.border
            dlg_proc(h, DLG_PROP_SET, prop={'border': self.border } )

        if id_ctl==n_btn_icon:
            #toggle button's checked
            id_btn = dlg_proc(h, DLG_CTL_HANDLE, name='btn_icon')
            b = button_proc(id_btn, BTN_GET_CHECKED)
            button_proc(id_btn, BTN_SET_CHECKED, not b)
            button_proc(id_btn, BTN_SET_BOLD, not b)

            #set imagelist+icon for button
            id_imglist = app_proc(PROC_GET_TAB_IMAGELIST, '')
            button_proc(id_btn, BTN_SET_KIND, BTNKIND_TEXT_ICON_VERT)
            button_proc(id_btn, BTN_SET_IMAGELIST, id_imglist)
            button_proc(id_btn, BTN_SET_IMAGEINDEX, int(b))

    def callback_splitter_left(self, id_dlg, id_ctl, data='', info=''):
        h = id_dlg
        print('callback_splitter_left')

    def callback_maindlg(self, id_dlg, id_ctl, data='', info=''):
        print('callback_maindlg(info=%s)' % repr(info))
        h = id_dlg

        n_chk_panel = dlg_proc(h, DLG_CTL_FIND, prop='chk_panel')
        n_edit = dlg_proc(h, DLG_CTL_FIND, prop='edit1')
        n_btn_cap = dlg_proc(h, DLG_CTL_FIND, prop='btn_caption')
        n_btn_dlg = dlg_proc(h, DLG_CTL_FIND, prop='btn_dlg')
        n_btn_paint = dlg_proc(h, DLG_CTL_FIND, prop='btn_paint')
        n_color = dlg_proc(h, DLG_CTL_FIND, prop='color')
        n_chk_dock = dlg_proc(h, DLG_CTL_FIND, prop='chk_dock')

        if id_ctl==n_chk_panel:
            d = dlg_proc(h, DLG_CTL_PROP_GET, index=n_color)
            dlg_proc(h, DLG_CTL_PROP_SET, index=n_color, prop={'vis': not d['vis']} )

        if id_ctl==n_btn_cap:
            d = dlg_proc(h, DLG_CTL_PROP_GET, index=n_edit)
            dlg_proc(h, DLG_PROP_SET, prop={'cap': 'entered: '+d['val'] } )

        if id_ctl==n_btn_dlg:
            hh = self.init_tempdlg()
            docked = dlg_proc(h, DLG_CTL_PROP_GET, index=n_chk_dock)['val'] == '1'
            if docked:
                dlg_proc(hh, DLG_DOCK, prop='R', index=h)
                dlg_proc(hh, DLG_SHOW_NONMODAL)
            else:
                dlg_proc(hh, DLG_SHOW_MODAL)


    def callback_listbox_drawitem(self, id_dlg, id_ctl, data='', info=''):

        #print('listbox on_draw_item, data:', data)
        id_canvas = data['canvas']
        index = data['index']
        rect = data['rect']
        index_sel = listbox_proc(self.id_listbox, LISTBOX_GET_SEL)

        #set bold for each 5th
        if index%5==0:
            style = FONT_B + FONT_I
            color = 0xB00000
        else:
            style = 0
            color = 0
        canvas_proc(id_canvas, CANVAS_SET_FONT, text='default', color=color, style=style)

        if index==index_sel:
            back_color = 0x806000+(0xF<<index)
            if back_color>0xFFFF00:
                back_color = 0xFFFF00
            canvas_proc(id_canvas, CANVAS_SET_BRUSH, color=back_color, style=BRUSH_SOLID)
            canvas_proc(id_canvas, CANVAS_SET_PEN, color=0x00F0F0, size=1, style=PEN_STYLE_SOLID)
            canvas_proc(id_canvas, CANVAS_RECT, x=rect[0], y=rect[1], x2=rect[2], y2=rect[3])
        else:
            canvas_proc(id_canvas, CANVAS_SET_BRUSH, color=0x6060D0, style=BRUSH_SOLID)
            canvas_proc(id_canvas, CANVAS_RECT_FILL, x=rect[0], y=rect[1], x2=rect[2], y2=rect[3])

        canvas_proc(id_canvas, CANVAS_TEXT,
            text='item index %d'%index,
            x=rect[0] + 20 + index*4,
            y=rect[1] + 2 )

        #this imagelist has 2 test icons: 0, 1
        img_list = app_proc(PROC_GET_TAB_IMAGELIST, '')
        imagelist_proc(img_list, IMAGELIST_PAINT, (id_canvas, rect[0], rect[1], index%2))


    def callback_listbox_check(self, id_dlg, id_ctl, data='', info=''):

        print('listbox option click')
        prop = dlg_proc(id_dlg, DLG_CTL_PROP_GET, name='chk1')
        chk = prop['val'] == '1'

        listbox_proc(self.id_listbox, LISTBOX_SET_DRAWN, index=(1 if chk else 0))


    def do_paint_mark(self, id_dlg, id_ctl):
        print('do_paint_mark')

        #paint circle of randon color
        n = randint(0, 0xfffff)
        canvas_id = dlg_proc(id_dlg, DLG_CTL_HANDLE, name='paint')
        canvas_proc(canvas_id, CANVAS_SET_PEN, color=0xA0)
        canvas_proc(canvas_id, CANVAS_SET_BRUSH, color=n+0xA0FF00)
        canvas_proc(canvas_id, CANVAS_RECT, x=0, y=0, x2=50, y2=50)
        canvas_proc(canvas_id, CANVAS_SET_BRUSH, color=n+0xA0A0)
        canvas_proc(canvas_id, CANVAS_ELLIPSE, x=0, y=0, x2=50, y2=50)

        #paint 2 first icons of standard file-tabs imagelist
        il = app_proc(PROC_GET_TAB_IMAGELIST, '')
        imagelist_proc(il, IMAGELIST_PAINT, (canvas_id, 0, 0, 0))
        imagelist_proc(il, IMAGELIST_PAINT, (canvas_id, 16, 16, 1))

    def callback_maindlg_paint_click(self, id_dlg, id_ctl, data='', info=''):
        self.do_paint_mark(id_dlg, id_ctl)

    def callback_tempdlg_on_key_down(self, id_dlg, id_ctl, data='', info=''):
        print('callback_tempdlg_on_key_down')

        state = app_proc(PROC_GET_KEYSTATE, '')
        str_key =\
            ('Meta+' if 'm' in state else '')+\
            ('Ctrl+' if 'c' in state else '')+\
            ('Alt+' if 'a' in state else '')+\
            ('Shift+' if 's' in state else '')+\
            app_proc(PROC_HOTKEY_INT_TO_STR, str(id_ctl))

        n_info = dlg_proc(id_dlg, DLG_CTL_FIND, 'label_info')
        dlg_proc(id_dlg, DLG_CTL_PROP_SET, index=n_info, prop={'cap': 'keypress: '+str_key })
        return True

    def callback_tempdlg_on_close_query(self, id_dlg, id_ctl, data='', info=''):
        print('callback_tempdlg_on_close_query')
        n_canclose = dlg_proc(id_dlg, DLG_CTL_FIND, 'chk_canclose')
        d = dlg_proc(id_dlg, DLG_CTL_PROP_GET, index=n_canclose)
        return d['val']=='1'

    def callback_tempdlg(self, id_dlg, id_ctl, data='', info=''):
        print('callback_tempdlg')

        n_close = dlg_proc(id_dlg, DLG_CTL_FIND, 'btn_close')
        n_clone = dlg_proc(id_dlg, DLG_CTL_FIND, 'btn_clonedlg')

        if id_ctl==n_close:
            dlg_proc(id_dlg, DLG_HIDE)

        if id_ctl==n_clone:
            print('  tempdlg begin')
            d = dlg_proc(id_dlg, DLG_PROP_GET)
            hh = self.init_tempdlg(d['x']+20, d['y']+20)
            dlg_proc(hh, DLG_SHOW_MODAL)
            dlg_proc(hh, DLG_FREE)
            print('  tempdlg end')


    def init_buttondlg(self):
        h=dlg_proc(0, DLG_CREATE)
        dlg_proc(h, DLG_PROP_SET, prop={'cap':'button test', 'w':400, 'h':300, 'w_min': 200, 'h_min': 250 })

        n=dlg_proc(h, DLG_CTL_ADD, 'button_ex')
        dlg_proc(h, DLG_CTL_PROP_SET, index=n, prop={'name': 'btn_border', 'cap':'toggle border',
            'x':10, 'y':20, 'w':120,
            'on_change': 'cuda_testing_dlg_proc.callback_buttondlg'
            } )

        n=dlg_proc(h, DLG_CTL_ADD, 'button_ex')
        dlg_proc(h, DLG_CTL_PROP_SET, index=n, prop={'name': 'btn_icon', 'cap':'test of icon',
            'x':10, 'y':50, 'w':120, 'h':50,
            'on_change': 'cuda_testing_dlg_proc.callback_buttondlg'
            } )

        return h

    def init_splitterdlg(self):
        h=dlg_proc(0, DLG_CREATE)
        dlg_proc(h, DLG_PROP_SET, prop={'cap':'splitter test', 'w':650, 'h':400, 'resize':True })

        n=dlg_proc(h, DLG_CTL_ADD, 'panel')
        dlg_proc(h, DLG_CTL_PROP_SET, index=n, prop={'name': 'panel_L', 'cap':'panel_L', 'x':0, 'y':0, 'w':200,
          'align':ALIGN_LEFT,
          'color':0x60c060,
           } )

        n=dlg_proc(h, DLG_CTL_ADD, 'panel')
        dlg_proc(h, DLG_CTL_PROP_SET, index=n, prop={'name': 'panel_R', 'cap':'panel_R', 'x':400, 'y':0, 'w':200,
          'align':ALIGN_RIGHT,
          'color':0xd08060
          } )

        n=dlg_proc(h, DLG_CTL_ADD, 'panel')
        dlg_proc(h, DLG_CTL_PROP_SET, index=n, prop={'name': 'panel_B', 'cap':'panel_B', 'x':0, 'y':0, 'h':100,
          'align':ALIGN_BOTTOM,
          'color':0xa0e080
          } )

        n=dlg_proc(h, DLG_CTL_ADD, 'panel')
        dlg_proc(h, DLG_CTL_PROP_SET, index=n, prop={'name': 'panel_LL', 'cap':'LL',
          'x':150, 'y':100, 'w':60, 'h':60,
          'p': 'panel_L',
          'a_l':None, 'a_t':('','-'), 'a_r':('',']'),
          'color':0x8080b0
          } )

        n=dlg_proc(h, DLG_CTL_ADD, 'splitter')
        dlg_proc(h, DLG_CTL_PROP_SET, index=n, prop={'name': 'sp_L', 'x':210, 'y':0,
          'align':ALIGN_LEFT,
          'props':(True,True),
          'act':True,
          'on_change': self.callback_splitter_left,
          } )

        n=dlg_proc(h, DLG_CTL_ADD, 'splitter')
        dlg_proc(h, DLG_CTL_PROP_SET, index=n, prop={'name': 'sp_R', 'x':220, 'y':0,
          'align':ALIGN_RIGHT,
          'props':(True,True),
          } )

        n=dlg_proc(h, DLG_CTL_ADD, 'splitter')
        dlg_proc(h, DLG_CTL_PROP_SET, index=n, prop={'name': 'sp_B', 'x':0, 'y':0,
          'align':ALIGN_BOTTOM,
          'props':(True,True),
          } )

        return h

    def init_maindlg(self):
        h=dlg_proc(0, DLG_CREATE)
        dlg_proc(h, DLG_PROP_SET, prop={'cap':'main dlg', 'x':100, 'y':50, 'w':400, 'h':300, 'resize':True, 'w_min': 200, 'h_min': 300, 'topmost':True })

        n=dlg_proc(h, DLG_CTL_ADD, 'label')
        dlg_proc(h, DLG_CTL_PROP_SET, index=n, prop={'name': '', 'cap':'label', 'x':10, 'y':10, 'w':50, 'tag': 'some_tag' })

        n=dlg_proc(h, DLG_CTL_ADD, 'check')
        dlg_proc(h, DLG_CTL_PROP_SET, index=n, prop={'name': 'chk_panel', 'cap':'show panel', 'val':True, 'x':60, 'y':8, 'w':200, 'act':True,
            'on_change': 'cuda_testing_dlg_proc.callback_maindlg' })

        n=dlg_proc(h, DLG_CTL_ADD, 'edit')
        dlg_proc(h, DLG_CTL_PROP_SET, index=n, prop={'name': 'edit1', 'val':'edit1', 'x':10, 'y':30, 'w':200} )

        n=dlg_proc(h, DLG_CTL_ADD, 'button')
        dlg_proc(h, DLG_CTL_PROP_SET, index=n, prop={'name': 'btn_caption', 'cap':'upd caption', 'x':10, 'y':60, 'w':100,
            'on_change': 'cuda_testing_dlg_proc.callback_maindlg'} )

        n=dlg_proc(h, DLG_CTL_ADD, 'button')
        dlg_proc(h, DLG_CTL_PROP_SET, index=n, prop={'name': 'btn_move', 'cap':'move button', 'x':120, 'y':60, 'w':100,
            'on_change': 'cuda_testing_dlg_proc.callback_main_movebtn'} )

        n=dlg_proc(h, DLG_CTL_ADD, 'colorpanel')
        dlg_proc(h, DLG_CTL_PROP_SET, index=n, prop={'name': 'color', 'cap': ' ', 'x':380, 'y':5, 'w':15, 'h':290, 'props':(1, 0xc0f0f0) } )
        #anchors of colorpanel
        dlg_proc(h, DLG_CTL_PROP_SET, index=n, prop={ 'a_l': None, 'a_r': ('', ']'), 'a_b': ('', ']'), 'sp_a': 6  } )

        n=dlg_proc(h, DLG_CTL_ADD, 'button')
        dlg_proc(h, DLG_CTL_PROP_SET, index=n, prop={'name': 'btn_x_panel', 'cap':'x', 'x':0, 'y':0, 'w':15, 'h':15,
            'p': 'color',
            'a_t': ('color', '-'),
            'on_change': 'cuda_testing_dlg_proc.callback_maindlg' } )

        n=dlg_proc(h, DLG_CTL_ADD, 'button')
        dlg_proc(h, DLG_CTL_PROP_SET, index=n, prop={'name': 'btn_dlg', 'cap':'temp dlg', 'x':10, 'y':200, 'w':100,
            'on_change': 'cuda_testing_dlg_proc.callback_maindlg'} )

        n=dlg_proc(h, DLG_CTL_ADD, 'button')
        dlg_proc(h, DLG_CTL_PROP_SET, index=n, prop={'name': 'btn_menu', 'cap':'menu here', 'x':10, 'y':230, 'w':100,
            'on_change': callback_main_menu } )

        n=dlg_proc(h, DLG_CTL_ADD, 'button')
        dlg_proc(h, DLG_CTL_PROP_SET, index=n, prop={'name': 'btn_paint', 'cap':'paint here', 'x':10, 'y':260, 'w':100,
            'on_change': self.callback_maindlg_paint_click } )

        n=dlg_proc(h, DLG_CTL_ADD, 'button')
        dlg_proc(h, DLG_CTL_PROP_SET, index=n, prop={'name': 'btn_callbk', 'cap':'complex callback', 'x':120, 'y':200, 'w':120,
            'on_change': 'module=cuda_testing_dlg_proc.testcall;func=callback_main_complex;info=1234;'} )

        n=dlg_proc(h, DLG_CTL_ADD, 'button')
        dlg_proc(h, DLG_CTL_PROP_SET, index=n, prop={'name': 'btn_ok', 'cap':'close', 'x':120, 'y':230, 'w':120,
            'on_change': callback_main_close } )

        n=dlg_proc(h, DLG_CTL_ADD, 'linklabel')
        dlg_proc(h, DLG_CTL_PROP_SET, index=n, prop={'name': 'link1', 'cap':'linklabel', 'x':10, 'y':150, 'w':120,
          'on_click': self.callback_linklabel_click } )

        n=dlg_proc(h, DLG_CTL_ADD, 'check')
        dlg_proc(h, DLG_CTL_PROP_SET, index=n, prop={'name': 'chk_dock', 'cap':'temp dlg: docked', 'x':10, 'y':170, 'w':120 } )

        #test for live callback
        n=dlg_proc(h, DLG_CTL_ADD, 'paintbox')
        dlg_proc(h, DLG_CTL_PROP_SET, index=n, prop={'name': 'paint', 'x':250, 'y':200, 'w':60, 'h':60,
            'on_click': self.callback_maindlg_paint_click } )

        nfocus = dlg_proc(h, DLG_CTL_FIND, 'edit1')
        dlg_proc(h, DLG_CTL_FOCUS, index=nfocus)
        return h


    def show_form_prop(self, h):
        res = dlg_proc(h, DLG_PROP_GET)
        print('form prop:', res)

        cnt = dlg_proc(h, DLG_CTL_COUNT)
        for n in range(cnt):
            res = dlg_proc(h, DLG_CTL_PROP_GET, index=n)
            print('c%d:'%n, res)


    def init_listdlg(self):

        h=dlg_proc(0, DLG_CREATE)
        dlg_proc(h, DLG_PROP_SET, prop={'cap':'listbox test', 'w':420, 'h':300 })

        n=dlg_proc(h, DLG_CTL_ADD, 'listbox_ex')
        dlg_proc(h, DLG_CTL_PROP_SET, index=n, prop={'name': 'list1',
            'x':10, 'y':10, 'w':400, 'h': 200,
            'on_draw_item': self.callback_listbox_drawitem,
            })

        h_list = dlg_proc(h, DLG_CTL_HANDLE, index=n)
        self.id_listbox = h_list

        for i in range(40):
            listbox_proc(h_list, LISTBOX_ADD, index=-1, text='item-%d'%i)
        listbox_proc(h_list, LISTBOX_SET_SEL, index=2)
        listbox_proc(h_list, LISTBOX_SET_ITEM_H, index=28)
        listbox_proc(h_list, LISTBOX_SET_DRAWN, index=1)

        n=dlg_proc(h, DLG_CTL_ADD, 'check')
        dlg_proc(h, DLG_CTL_PROP_SET, index=n, prop={'name': 'chk1', 'cap': 'Owner-drawn listbox',
            'x':10, 'y':220, 'w':400,
            'val': True,
            'act': True,
            'on_change': self.callback_listbox_check,
            })

        return h


    def init_tempdlg(self, x=150, y=150):
        h=dlg_proc(0, DLG_CREATE)
        dlg_proc(h, DLG_PROP_SET, prop={'cap':'temp dlg', 'x':x, 'y':y, 'w':300, 'h':200,
            'color': 0xc0c0c0,
            'on_key_down': 'cuda_testing_dlg_proc.callback_tempdlg_on_key_down',
            'on_close_query': 'cuda_testing_dlg_proc.callback_tempdlg_on_close_query',
            })

        n=dlg_proc(h, DLG_CTL_ADD, 'button')
        dlg_proc(h, DLG_CTL_PROP_SET, index=n, prop={'name': 'btn_close', 'cap':'close', 'x':20, 'y':20, 'w':100,
            'on_change': 'cuda_testing_dlg_proc.callback_tempdlg' })

        n=dlg_proc(h, DLG_CTL_ADD, 'button')
        dlg_proc(h, DLG_CTL_PROP_SET, index=n, prop={'name': 'btn_clonedlg', 'cap':'clone dlg', 'x':20, 'y':50, 'w':100,
            'on_change': 'cuda_testing_dlg_proc.callback_tempdlg' })

        n=dlg_proc(h, DLG_CTL_ADD, 'check')
        dlg_proc(h, DLG_CTL_PROP_SET, index=n, prop={'name': 'chk_canclose', 'cap':'can close form', 'x':20, 'y':80, 'w':100, 'val':True })

        n=dlg_proc(h, DLG_CTL_ADD, 'label')
        dlg_proc(h, DLG_CTL_PROP_SET, index=n, prop={'name': 'label_info', 'cap':'(shows key press)', 'x':20, 'y':160, 'w':100 })

        return h


    def init_editor_dlg(self):

        h=dlg_proc(0, DLG_CREATE)
        dlg_proc(h, DLG_PROP_SET, prop={'cap':'editor test', 'w':750, 'h':400 })

        n=dlg_proc(h, DLG_CTL_ADD, 'editor')
        dlg_proc(h, DLG_CTL_PROP_SET, index=n, prop={'name': 'ed',
            'align': ALIGN_TOP,
            'sp_a': 6,
            'h': 350,
            })

        h_editor = dlg_proc(h, DLG_CTL_HANDLE, index=n)
        ed0 = Editor(h_editor)
        ed0.set_text_all(
"""unit Test;
//comment
procedure Test(var Num: string);
begin
  Writeln(Num, 'Test str');
end;
""")
        #ed0.set_caret(0, 3, 0, 2)
        #ed0.set_prop(PROP_CARET_SHAPE, 2)
        ed0.set_prop(PROP_MINIMAP, True)
        ed0.set_prop(PROP_LEXER_FILE, 'Pascal')

        dlg_proc(h, DLG_CTL_FOCUS, index=n)

        return h


    def callback_main_movebtn(self, id_dlg, id_ctl):
        print('callback_main_movebtn')
        d = dlg_proc(id_dlg, DLG_CTL_PROP_GET, index=id_ctl)
        dlg_proc(id_dlg, DLG_CTL_PROP_SET, index=id_ctl, prop={'x': d['x']+10, 'y': d['y']+8 } )


    def test_pages(self):
        id = dlg_proc(0, DLG_CREATE)

        dlg_proc(id, DLG_PROP_SET, {'w':400, 'h':300, 'cap':'Test type=pages'})

        n = dlg_proc(id, DLG_CTL_ADD, 'pages')
        dlg_proc(id, DLG_CTL_PROP_SET, index=n, prop={'name': 'my', 'x':10, 'y':10, 'w':380, 'h':280, 'items': 'page-A\tpage-B' })

        n = dlg_proc(id, DLG_CTL_ADD, 'check')
        dlg_proc(id, DLG_CTL_PROP_SET, index=n, prop={'name': 'check0', 'x':10, 'y':10, 'w':300, 'cap':'check-A', 'p':'my.0' })

        n = dlg_proc(id, DLG_CTL_ADD, 'check')
        dlg_proc(id, DLG_CTL_PROP_SET, index=n, prop={'name': 'check1', 'x':20, 'y':20, 'w':300, 'cap':'check-B', 'p':'my.1' })

        n = dlg_proc(id, DLG_CTL_ADD, 'label')
        dlg_proc(id, DLG_CTL_PROP_SET, index=n, prop={'name': 'lab1', 'x':20, 'y':50, 'w':300, 'cap':'label-B', 'p':'my.1' })

        dlg_proc(id, DLG_SHOW_MODAL)
        dlg_proc(id, DLG_FREE)

    def test_toolbar(self):
        dir_icons = os.path.join(app_path(APP_DIR_DATA), 'sideicons', 'octicons_24x24')
        icon1 = os.path.join(dir_icons, 'console.png')
        icon2 = os.path.join(dir_icons, 'find.png')
        print('icon1:', icon1)
        print('icon2:', icon2)

        id = dlg_proc(0, DLG_CREATE)

        dlg_proc(id, DLG_PROP_SET, {'w':400, 'h':300, 'cap':'Test type=toolbar', 'resize':True})

        n = dlg_proc(id, DLG_CTL_ADD, 'toolbar')
        dlg_proc(id, DLG_CTL_PROP_SET, index=n, prop={'name': 'tb', 'x':0, 'y':0, 'w':20, 'h':40, 'a_r': ('', ']'), 'color': 0x80B080 })

        tb_id = dlg_proc(id, DLG_CTL_HANDLE, index=n)

        toolbar_proc(tb_id, TOOLBAR_SET_ICON_SIZES, index=24, index2=24)
        n1 = toolbar_proc(tb_id, TOOLBAR_ADD_ICON, text=icon1)
        n2 = toolbar_proc(tb_id, TOOLBAR_ADD_ICON, text=icon2)
        print('icon indexes:', n1, n2)
        toolbar_proc(tb_id, TOOLBAR_ADD_BUTTON, text='Callback', command=self.show_about, index2=n1)
        toolbar_proc(tb_id, TOOLBAR_ADD_BUTTON, text='Hotkeys help', command=2707, index2=n2)

        dlg_proc(id, DLG_SHOW_MODAL)
        dlg_proc(id, DLG_FREE)


    def test_treeview(self):
        id = dlg_proc(0, DLG_CREATE)

        dlg_proc(id, DLG_PROP_SET, {'w':400, 'h':300, 'cap':'Test type=treeview'})

        n = dlg_proc(id, DLG_CTL_ADD, 'treeview')
        dlg_proc(id, DLG_CTL_PROP_SET, index=n, prop={'name': 'my', 'x':10, 'y':10, 'w':380, 'h':280,
            'on_fold': self.callback_treeview_on_fold,
            'on_unfold': self.callback_treeview_on_unfold,
            })

        self.h_tree = dlg_proc(id, DLG_CTL_HANDLE, index=n)
        tree_proc(self.h_tree, TREE_THEME)

        item0a = tree_proc(self.h_tree, TREE_ITEM_ADD, id_item=0, index=-1, text='item 0a')
        item0b = tree_proc(self.h_tree, TREE_ITEM_ADD, id_item=0, index=-1, text='item 0b')
        item1a = tree_proc(self.h_tree, TREE_ITEM_ADD, id_item=item0a, index=-1, text='sub item 1a')
        item1b = tree_proc(self.h_tree, TREE_ITEM_ADD, id_item=item0a, index=-1, text='sub item 1b')
        item2a = tree_proc(self.h_tree, TREE_ITEM_ADD, id_item=item1a, index=-1, text='sub item 2a')

        tree_proc(self.h_tree, TREE_ITEM_UNFOLD_DEEP, id_item=0)

        dlg_proc(id, DLG_SHOW_MODAL)
        dlg_proc(id, DLG_FREE)


    def callback_treeview_on_fold(self, id_dlg, id_ctl, data='', info=''):
        prop = tree_proc(self.h_tree, TREE_ITEM_GET_PROPS, id_item=data)
        print('callback_treeview_on_unfold,', 'item:', prop)

    def callback_treeview_on_unfold(self, id_dlg, id_ctl, data='', info=''):
        prop = tree_proc(self.h_tree, TREE_ITEM_GET_PROPS, id_item=data)
        print('callback_treeview_on_unfold,', 'item:', prop)


    def test_sidepanel(self):
        print('test_sidepanel')
        title = 'Side dialog'
        id_dlg = self.init_maindlg()
        icon_name = 'project.png'

        app_proc(PROC_SIDEPANEL_ADD_DIALOG, (title, id_dlg, icon_name) )
        app_proc(PROC_SIDEPANEL_ACTIVATE, title)

    def show_about(self):
        ed.cmd(2700)

    def test_btn(self):
        h = self.init_buttondlg()
        dlg_proc(h, DLG_SHOW_MODAL)
        dlg_proc(h, DLG_FREE)

    def test_splitter(self):
        h = self.init_splitterdlg()
        dlg_proc(h, DLG_SHOW_MODAL)
        dlg_proc(h, DLG_FREE)

    def test_listbox(self):
        h = self.init_listdlg()
        dlg_proc(h, DLG_SHOW_MODAL)
        dlg_proc(h, DLG_FREE)

    def test_editor(self):
        h = self.init_editor_dlg()
        dlg_proc(h, DLG_SHOW_MODAL)
        dlg_proc(h, DLG_FREE)

